'Blitzdatenlogger, ES-M32 mit LCD und EEPROM

$regfile = "m32def.dat"
$crystal = 11059200
$hwstack = 16
$swstack = 32
$framesize = 128

Baud = 9600


Dim N As Byte
Dim U As Word
Dim D As Word
Dim A As Byte                                               'Adresse
Dim Trigger As Byte
Dim Sta As Byte                                             'Startadresse , Trigerpunkt

Dim Eeadr As Word
Dim I As Byte
Dim J As Byte
Dim B As Byte

Dim Daten(128) As Word

Config Adc = Single , Prescaler = 8 , Reference = Off
Start Adc

Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2

Initlcd
Cls
Locate 1 , 1
Lcd "Logger "
Ddrd = 255
Open "com1:" For Binary As #1

U = Getadc(0)
A = 1
Sta = 0
Trigger = 0
Eeadr = 0

Do
  'Portd.4 = 1
  D = Getadc(0)
  'Portd.4 = 0
  Daten(a) = D                                              'Ringpuffer
  U = U * 15
  U = U + D
  Shift U , Right , 4
 ' Print U ; D ; Trigger                                     'Mittelwert U

  If Trigger = 1 Then
    If Sta = A Then
       Print "Blitz!"
       Locate 1 , 1
       Lcd "Blitz Nr. "
       Lcd I
       For N = 1 To 128
          A = A + 1
          If A > 128 Then A = 1
          D = Daten(a)
          Print D ; "  ";
          D = D / 2
          B = D And 255
          If Eeadr < 1024 Then Writeeeprom B , Eeadr
          Eeadr = Eeadr + 1
       Next N
       I = I + 1
       Sta = 0
       Trigger = 0
    End If
    A = A + 1
    If A > 128 Then A = 1
  Else
    D = D + 30                                              '> 150 mV unter Mittel
    If D < U Then
      Trigger = 1
      Sta = A + 120                                         'getrigegrt
      If Sta > 128 Then Sta = Sta - 128                     'berlauf?
    End If
    A = A + 1
    If A > 128 Then A = 1
  End If
  'Waitms 200
  J = Ischarwaiting(#1)
  If J > 0 Then
    Get #1 , J
    Eeadr = J * 128
    For N = 1 To 128
      Readeeprom B , Eeadr
      Put #1 , B
      Eeadr = Eeadr + 1
    Next N
  End If
Loop

End